#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>    
#include <sys/types.h>
#include <sys/socket.h>    
#include <netinet/in.h>    
#include <arpa/inet.h>
#include <netdb.h>
#include <signal.h>

const char *USAGE="USAGE: logbroadcast <numeric-destination-ip> <port> [switches]\nSwitches:\n -U <userid> - run as user\n -G <groupid> - run as group\n";
#define BUFFERSIZE 1024

int main(int argc, char *argv[])    
{       
 int val=1;
 int sockfd;
 struct sockaddr_in their_addr; // connector's address information
 int numbytes;
 int i; char nextarg=0;
 int validusage=1;
 their_addr.sin_port=0;
 their_addr.sin_addr.s_addr=INADDR_NONE;
 for (i=1; i<argc; i++)
 {
  char *p=argv[i];
  if (*p=='-') {nextarg=*(p+1); p+=2; if (*p=='\0') continue;}
  else if (nextarg==0)
  {
   if (their_addr.sin_addr.s_addr==INADDR_NONE) their_addr.sin_addr.s_addr=inet_addr(p);
   else if (their_addr.sin_port==0) their_addr.sin_port=htons(atoi(p));
   continue;
  }
  switch(nextarg)
  {
   case 'U': setuid(atoi(p)); break;
   case 'G': setgid(atoi(p)); break;
   default: fprintf(stderr,"Unrecognised switch '-%c'",nextarg);
  }
  nextarg=0;
 }
 their_addr.sin_family = AF_INET;     // host byte order
 if (their_addr.sin_port==0) {
  fprintf(stderr,"Invalid port. Must be a number from 1 to 65535.\n");
  validusage=0;
 }
 if (their_addr.sin_addr.s_addr==INADDR_NONE) {
  fprintf(stderr,"Invalid IP - must be x.x.x.x numeric.\n");
  validusage=0;
 }
 if (!validusage)
 {
  fprintf(stderr,USAGE); return 1;
 }
 signal(SIGHUP,SIG_IGN);
 bzero(&(their_addr.sin_zero), 8);    // zero the rest of the struct

 {
  char mess[BUFFERSIZE];
  int pos=0;
  while(1) 
  {
   int count;
   count=read(STDIN_FILENO,mess+pos,BUFFERSIZE-pos);
   if (count>0)
   {
    count+=pos;
    do {
     while (pos<count && *(mess+pos)!='\r' && *(mess+pos)!='\n') pos++;
     if (*(mess+pos)=='\r' || *(mess+pos)=='\n' || pos==BUFFERSIZE)
     {
      if (pos>0) {
       if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
       {
        perror("socket");
        exit(1);        
       }
       setsockopt(sockfd,SOL_SOCKET,SO_BROADCAST,&val,sizeof(int));
       if ((numbytes=sendto(sockfd, mess, pos, 0,
           (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) < 1)
       {
        perror("sendto");          
        exit(1);       
       }
       close(sockfd);       
      }
      while (pos<count && (*(mess+pos)=='\r' || *(mess+pos)=='\n')) pos++;
      memcpy(mess,mess+pos,count-=pos);
      pos=0;
     }
    } while (pos<count);
   }
  }
 }
 return 0;    
} 
